#
# $PROJECT: Include Makefiles
#
# $VER: autodoc.mk 41.1 (31.12.95)
#
# by
#
# Stefan Ruppert , Windthorststrasse 5 , 65439 Floersheim , GERMANY
#
# (C) Copyright 1995
# All Rights Reserved !
#
# $HISTORY:
#
# 31.12.95 : 041.001 : added readme target
# 21.07.95 : 001.001 : initial
#

##############################################################################
#
# commands
#

RX     = Sys:Rexxc/rx


##############################################################################
#
# generate autodocs
#

$(filter %.doc,$(AUTODOC)) : $(SRCS)
	 c:swtools/makedoc $^ AUTODOC $@ $(MAKEDOCFLAGS)

##############################################################################
#
# convert autodoc to an amigaguide
#

$(GUIDE) : $(AUTODOC)
	c:swtools/makexref FROM $^ TO t:tmp.xref NOICON VERBOSE CATEGORY Tmp
	c:swtools/loadxref t:tmp.xref INDEX
	c:swtools/xrefconvert FROM $(filter %.doc,$^) TO $(@D) VERBOSE $(MAKEGUIDEFLAGS)
	c:swtools/expungexref Tmp
	delete t:tmp.xref

$(XREF) : $(AUTODOC)
	c:swtools/expungexref $(XREFCATEGORY)
	c:swtools/makexref FROM $^ TO $@ NOICON VERSION $(VERSION) REVISION $(REVISION) \
							 VERBOSE CATEGORY $(XREFCATEGORY)

##############################################################################
#
# generate standard readme
#

readme: force
	$(RX) makereadme.rexx $(NAME) $(HISTORY) $(PRJREADME) $(VERSTR) $(DISTTYPE) $(PLACE) $(SHORT) >$(README)

force:

